package dev;

import dev.util.ServerValidator;

import java.util.function.Predicate;

class Main {
    private static final boolean NO_ARGS_OK = true;
    static final int REQUIRED_ARGS = 2;

    static final Predicate<Integer> argsValidator = numOfArgs ->
            numOfArgs == REQUIRED_ARGS || (NO_ARGS_OK && numOfArgs == 0);

    public static void main(String[] args) {
        if (!argsValidator.test(args.length)) {
            System.out.println("\nUngültige Anzahl an Parametern übergeben");
            errorMessage();
            return;
        }

        Server server;
        if (args.length == REQUIRED_ARGS) {
            if (!ServerValidator.isPortValid(args[0]) || !ServerValidator.isPwValid(args[1])) {
                System.out.println("\nUngültige Parameter");
                errorMessage();
                return;
            }
            int port = Integer.parseInt(args[0]);
            String pw = args[1];
            server = new Server(port, pw);
        } else {
            server = new Server();
        }
        server.run();
    }

    private static void errorMessage() {
        System.out.println("Verwendung:");
        System.out.println("xyz.jar [{PORT} {PASSWORT}]");
        System.out.println("------------------------------------------------------------------");
    }

}
