package dev.util;

public class ServerExceptions extends Exception {
    private ServerExceptions() { /* _ */ }

    private ServerExceptions(String message) {
        super("ERROR " + message);
    }

    public static final class SyntaxError extends ServerExceptions {
        public SyntaxError(String message) {
            super("SYNTAX ERROR " + message);
        }
    }

    public static class UnknownCommand extends Exception {
        public UnknownCommand() {
            super("UNKNOWN COMMAND");
        }
    }
}
