package dev.util;

import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.Locale;

public class StringHelper {

    public static String toLowerCase(String text) throws ServerExceptions.SyntaxError {
        if (text == null || text.isEmpty()) throw new ServerExceptions.SyntaxError("Leere Zeichenkette für LOWERCASE");
        return text.toLowerCase(Locale.GERMAN);
    }

    public static String toUpperCase(String text) throws ServerExceptions.SyntaxError {
        if (text == null || text.isEmpty()) throw new ServerExceptions.SyntaxError("Leere Zeichenkette für UPPERCASE");
        return text.toUpperCase(Locale.GERMAN);
    }

    public static String reverseString(String text) throws ServerExceptions.SyntaxError {
        if (text == null || text.isEmpty()) throw new ServerExceptions.SyntaxError("Leere Zeichenkette für REVERSE");
        if (text.length() == 1) return text;
        return new StringBuilder(text).reverse().toString();
    }

    static int countBytesInString(String input) {
        if (input == null) return 0;
        return input.getBytes(StandardCharsets.UTF_8).length;
    }

    // Das hier wird wohl nur von Tests benutzt, also sollte es auch in den Tests stecken
    static String generateSingleByteString(char character, int sizeInBytes) {
        if (sizeInBytes < 1 || String.valueOf(character).getBytes(StandardCharsets.UTF_8).length > 1) return "";

        byte[] testBytes = new byte[sizeInBytes];
        Arrays.fill(testBytes, String.valueOf(character).getBytes(StandardCharsets.UTF_8)[0]);

        return new String(testBytes, StandardCharsets.UTF_8);
    }
}
